import React, {useState, useEffect} from 'react';
import AddressUser from '../../components/AddressList/AddressUser';
import axiosRequest from '../../utils/request';
import {ActivityIndicator} from "antd-mobile";
import Document from 'react-document-title'
import Empty from '../Empty'


const Communicate = (props) => {
    const [loading, setLoading] = useState(false);
    const [data, setData] = useState([]);
    const [title, setTitle] = useState([])

    const getData = (id) => {
        setLoading(true);
        axiosRequest({
            method: 'post',
            url: `/idtAppServiceV6/oApp/getSearchAddressBook?deptId=${id}`,
        }).then(res => {
            setLoading(false);
            setData(res.userList)
            setTitle(res.deptList)
        });
    };
    useEffect(() => {
        const {id} = props.match.params;
        getData(id)
    }, []);


    return (
        <Document title="通讯录">
            <div>
                <ActivityIndicator
                    toast
                    text="加载中..."
                    animating={loading}
                />
                <div className='breadBox'>
                    {title.length > 0 ? title[0].depts : ''}
                </div>
                <div className='adMainBox'>
                    {data.length > 0 ?  <AddressUser data={data}/> : <Empty/>}

                </div>
            </div>

        </Document>
    );
};

export default Communicate;

