import {useRef, useCallback, useEffect} from 'react';

const UseDebounce = (fn, delay, dep = []) => {
    const {current} = useRef({fn, timer: null});
    useEffect(() => {
        current.fn = fn
    }, [fn])
    return useCallback((...args) => {
        if (current.timer) {
            clearTimeout(current.timer)
        }
        current.timer = setTimeout(() => {
            current.fn.call(this, ...args)
        }, delay)
    })
};

export default UseDebounce;
