import {useRef, useCallback, useEffect} from 'react';

const UseThrottle = (fn, delay, dep = []) => {
    const {current} = useRef({fn, timer: null});
    useEffect(() => {
        current.fn = fn
    }, [fn])
    return useCallback((...args) => {
        if (!current.timer) {
           current.timer = setTimeout(() => {
               delete current.timer
           }, delay);
           current.fn.call(this, ...args)
        }
    }, dep)
};

export default UseThrottle;
